# Sondertutorium 2
# Die Dateien enthalten die Themen: Boolsche Werte, If, printf, Funktionen, Funktionsdateien & ein Demo Beispiel

# Boolsche Werte werden als 0 und 1 gespeichert.
x= true
y= false
# x gleich y?
x == y
2 == 3.4
# ungleich
x != y
# Mit Matrizen
B=[ 1 2; 3 4]
B == [1 3; 2 4]
B == 3
# Achtung: "true" entspricht der 1. Damit ist folgendes moeglich
true+true
3*true
# Verknuepfungen: UND und ODER
x && y
x || y

# Formatierte Ausgabe: printf (kurz!, mehr Details in der Doku)
# Wenn man ein langes Skript erstellt werden vermutlich Ergebnisse berechnet. Diese sollte man schoen formatiert ausgeben und nicht nur als eine Aneinanderreihung von Zeilen der Art "ans=0.3".
# Man will schliesslich auch nicht immer das tatsaechliche Skript betrachten muessen, um zu wissen, was gerade angezeigt wird.
# Eine Loesung ist die formatierte Textausgabe mit "printf". Dieser Befehl gibt den ihm uebergebenen Text aus. 
# Dieser Text ist durch Anfuehrungszeichen begrenzt und kann verschiedene Sonderzeichen enthalten.
# Als erstes Platzhalter: zum Beispiel %i oder %f
x=2;
printf("Die Summe von x=%i mit sich selbst ist x+x=%i",x,x+x);
# Nach dem Text stehen durch Komma getrennt zwei Zahlen (x und x+x). Diese werden als Integer (also ganze Zahl, deswegen das "i") der Reihe nach an die Platzhalterstellen eingefuegt
# Vorsicht: hier wird gerundet damit auch tatsaechlich nur eine ganze Zahl an die Stelle des Platzhalters gesetzt wird!
# Richtig Sinn macht dieser Befehl natuerlich nur in Skripten und nicht, wenn ihr ihn in die Konsole eintippt. Tippt einfach mal "sondertutorium2" in die Konsole, um dieses Skript auszufuehren (Ihr muesst dafuer im richtigen Verzeichnis sein! Also wie beim ersten Tutorium mit pwd und cd an die richtige Stelle navigieren)
# Der Platzhalter #i konvertiert eine Variable in eine ganze Zahl, aber es gibt noch viel mehr Moeglichkeiten zur Darstellung!
# Expotentialdarstellung %e
# Einfache/doppelte Genauigkeit %f und %d
# Fuer ganze Zahlen: Darstellung bezueglich anderer Basen:
# octal %o, dezimal #u, hexadezimal %x

# Wenn ein Satz zu lang wird, werden Zeilenumbrueche benoetigt! Das ist ein nichtdarstellbares Zeichen, Schreibweise "\n" (newline)
x=2.3
printf("\nDie Summe von x=%i mit sich selbst ist \nx+x=%i\n",x,x+x);
printf("Neuer Versuch: %f + %f = %f\n",x,x,x+x);

# Es gibt noch mehr nicht darstellbare Zeichen, zum Beispiel \t (Tabulator, also ein Abstand) und \r (carriage return, die Schreibposition wird auf den Anfang der Zeile zurueckgesetzt)
printf("Was passiert hier\rDas\n");

# "\" und "%" leiten also Sonderzeichen und Platzhalter ein, wie druckt man nun aber diese beiden Zeichen??
printf("Ein newline Zeichen wird mit \\n bezeichnet\nund ein Prozentzeichen mit %%.\nAnfuehrungszeichen werden mit \" dargestellt");

# Wenn euch die Darstellung einer Zahl zu ungenau ist, dann kann man Octave anweisen, mehr Stellen anzuzeigen
pi
format long
pi
format short
pi

# Diese Ausfuehrungen zur Textformatierung sind keinewegs erschoepfend, wenn euch etwas fehlt, hilft also vielleicht ein blick in die Doku. Zum Beispiel ist es moeglich auch Matrizen mit printf ausgeben zu lassen! 

# Bedingte Anweisungen: If
# Diese Anweisung dient fuer einfache Fallunterscheidungen.

if (x==true)
  e=90;
elseif (x==false)
  e=0;
else
  printf("Diese Zeile wird niemals ausgefuehrt!");
endif

# Vorsicht: Jeder Ausdruck der von 0 verschieden ist, wird als true angesehen!
if (3)
  printf("3 wird als wahr interpretiert, aber 3==true liefert:");
  3==true
    printf("Warum? Hier wird 3==1 getestet!\n");
endif


# Ein kleines Beispiel (Finden eines maximalen Elements einer Matrix; Uebung zu boolschen Variablen, Matrizen und dem "find" Befehl)

# Ausgehend von der Matrix
A=[4 4 2; 1 2 4; 4 5 2]
# wollen wir das maximale Element der Matrix finden und eine Vorschrift angeben, die das automatisch hinbekommt.

# Folgender Ausdruck gibt uns den Wert der maximalen Elemente innerhalb jeder Spalte an
max(A)
# Das ist also selber wieder ein Vektor auf den wir wieder max Anwenden koennen
max(max(A))
# um das maximale Element der Matrix zu finden
# Um das betragsgoesste Element zu finden, muessten wir den Absolutbetrag betrachten
abs(A)
# und dann wie oben fortfahren.

# Um nun die Position des maximalen Elements zu bestimmen, muesen wir die Stelle(n) identifizieren, an der/denen dieser Wert angenommen wird. Man betrachtet also die (boolsche) Matrix
A==max(max(A))
# "find" gibt die Stellen an, an denen ein von 0 verschiedener Wert zu finden ist.
# Dabei zaehlt es die Matrix entlang der Dimensionen durch. Also erst die erste Spalte!
pos=find(A==max(max(A)))
# Wenn mehrere Elemente den maximalen Betrag annehmen, handelt es sich bei pos um einen Vektor.
pos = pos(1) # Jetzt untersuchen wir nurnoch das erste Vorkommen
# Um daraus einen Index, also hier (3,2) zu machen ist das Rechnen mit Rest, also Modulo (mod) noetig. Ebenfalls hilfreich: Funktionen die Abrunden (floor).
# Eine Moeglichkeit stellt folgende Formel dar (fuer eine 3x3 Matrix!): 
A(mod(pos+2,3)+1, floor((pos-1)/3)+1)
 
# Matrizen werden wohl intern als lange Vektoren gespeichert, weswegen ebenfalls
A(pos)
# zum Ziel fuehrt. (Dieses Beispiel uebt also lediglich den Umgang mit Octave und das Modulo-Rechnen)

